#ifndef _MEDIUMS_H
#define _MEDIUMS_H

int plump_mediumIsSupported(plumpmedium_t medium);
int plump_mediumGetFunctionTable(plumpmedium_t medium, plumpfunc_t *functions);

#if defined(MEDIUM_HAS_PTRACE)

int ptrace_okay();

plumpmedium_t ptrace_getMedium();

int ptrace_open(plump_t *p, int pid, unsigned long access);
int ptrace_close(plump_t *p);

int ptrace_execContinue(plump_t *p, plumpaddr_t start, plumpaddr_t *stop, unsigned long flags);
int ptrace_execStop(plump_t *p);

int ptrace_memoryWrite(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesWritten);
int ptrace_memoryRead(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesRead);
int ptrace_memoryIsValid(plump_t *p, plumpaddr_t addr);
int ptrace_memoryGetEndOfSegment(plump_t *p, plumpaddr_t addr, plumpaddr_t *end);

int ptrace_registersSet(plump_t *p, plumpreg_t *registers, unsigned long numRegisters);
int ptrace_registersGet(plump_t *p, plumpreg_t *registers, unsigned long numRegisters);

#endif

#if defined(MEDIUM_HAS_PROCFS)

int procfs_okay();

plumpmedium_t procfs_getMedium();

int procfs_open(plump_t *p, int pid, unsigned long access);
int procfs_close(plump_t *p);

int procfs_execContinue(plump_t *p, plumpaddr_t start, plumpaddr_t *stop, unsigned long flags);
int procfs_execStop(plump_t *p);

int procfs_memoryWrite(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesWritten);
int procfs_memoryRead(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesRead);
int procfs_memoryIsValid(plump_t *p, plumpaddr_t addr);
int procfs_memoryGetEndOfSegment(plump_t *p, plumpaddr_t addr, plumpaddr_t *end);

int procfs_registersSet(plump_t *p, plumpreg_t *registers, unsigned long numRegisters);
int procfs_registersGet(plump_t *p, plumpreg_t *registers, unsigned long numRegisters);

#endif

#if defined(MEDIUM_HAS_DBGAPI)

int dbgapi_okay();

plumpmedium_t dbgapi_getMedium();

int dbgapi_open(plump_t *p, int pid, unsigned long access);
int dbgapi_close(plump_t *p);

int dbgapi_execContinue(plump_t *p, plumpaddr_t start, plumpaddr_t *stop, unsigned long flags);
int dbgapi_execStop(plump_t *p);

int dbgapi_memoryWrite(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesWritten);
int dbgapi_memoryRead(plump_t *p, plumpaddr_t addr, void *buffer, unsigned long bufferLength, unsigned long *bytesRead);
int dbgapi_memoryIsValid(plump_t *p, plumpaddr_t addr);
int dbgapi_memoryGetEndOfSegment(plump_t *p, plumpaddr_t addr, plumpaddr_t *end);

int dbgapi_registersSet(plump_t *p, plumpreg_t *registers, unsigned long numRegisters);
int dbgapi_registersGet(plump_t *p, plumpreg_t *registers, unsigned long numRegisters);

#endif

#endif
